Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.beans
Class AbleNetwork

    java.lang.Object
      com.ibm.able.AbleObject
          com.ibm.able.beans.AbleNetwork

All Implemented Interfaces:
  AbleBean, AbleDataBufferManager, AbleEventListener, AbleEventListenerManager, AbleEventQueueManager, AbleEventQueueProcessor, AblePropertyChangeManager, AbleSerializable, java.io.Serializable

Direct Known Subclasses:
  AbleBackPropagation, AbleRadialBasisFunctionNet, AbleSelfOrganizingMap, AbleTemporalDifferenceLearning

public class AbleNetwork
extends AbleObject
implements java.io.Serializable

This class is the base class for all Neural Network AbleObjects.

See Also:
  Serialized Form

Field Summary
`protected double[]` | `activations` The activations of each unit in the network
`protected boolean` | `breakPointFlag` Indicates whether a breakpoint fired during the last process()
`protected java.util.Vector` | `breakPoints` List of breakpoints defined for this object
`double[]` | `inNum` The numeric input buffer
`protected AbleBreakPoint` | `lastBreakPoint` The last breakpoint that fired
`static java.lang.String[]` | `MODE_NAMES` Labels for the train, test and run modes for GUI use.
`protected java.lang.String` | `netArchitecture` The network architecture string
`protected long` | `netEpoch` The current training epoch
`protected int` | `netMode` The network mode, train, test or run
`protected java.lang.String` | `netModelType` The type of network model
`protected long` | `netRecInx` The current index into the record
`protected long` | `netStepsPerEpoch` The number of steps before each weight adjustment
`static int` | `NNRUN` Application or Run mode weights are not adjusted output is produced
`static int` | `NNTEST` Test mode weights are not adjusted performance is tested (errors are computed)
`static int` | `NNTRAIN` Training mode weights are adjusted
`double[]` | `outNum` The numeric output buffer

Fields inherited from class com.ibm.able.AbleObject
`changed, chgSupport, comment, dataFlowEnabled, defaultName, destBufferConnections, eventQueue, fileName, inputBuffer, listeners, logger, name, outputBuffer, parent, properties, propertyConnectionMgr, sourceBufferConnections, state, stateChgSupport, trace`

Constructor Summary
`AbleNetwork()` default constructor
`AbleNetwork(java.lang.String name)` Construct a network with specified name
`AbleNetwork(java.lang.String name, java.lang.String architecture)` Construct a network with specified name and architecture.

Method Summary
`boolean` | `breakPointReached()` Check if any breakpoint has fired
`void` | `changeNetArchitecture(java.lang.String architecture)` Change the network architecture.
`void` | `clearAllBreakPoints()` Clear all breakpoint set on this network.
`void` | `clearBreakPoint(AbleBreakPoint breakpoint)` Clear the specified breakpoint from this network.
`void` | `clearBreakPoint(java.lang.String parameter, java.lang.String condition, java.lang.String value)` Clear the specified breakpoint from this network.
`void` | `clearLastBreakPoint()` Clear the last breakpoint to fire.
`void` | `endEpoch()` Perform the end of epoch processing.
`AbleBreakPoint` | `getLastBreakPoint()` Get the last breakpoint to fire.
`long` | `getNetEpoch()`
`int` | `getNetMode()` Get the current operating mode of the network.
`long` | `getNetRecInx()`
`long` | `getNetStepsPerEpoch()`
`java.util.Vector` | `getNetworkGraphicData()` return data on the network architecture, activations, and weights for display by the AbleNetworkGraphicView custom inspector
`void` | `setBreakPoint(java.lang.String parameter, java.lang.String condition, java.lang.String value)` Set a breakpoint on this network.
`protected void` | `setDefaults()` Set up the event queue behavior No timer processing and no asynch event processing
`void` | `setNetArchitecture(java.lang.String architecture)` Set the network architecture.
`void` | `setNetMode(int mode)` Set the operating mode of the network.
`void` | `setNetStepsPerEpoch(long numSteps)`
`boolean` | `testBreakPoints()` Check all active breakpoints to see if any fire.

Methods inherited from class com.ibm.able.AbleObject
`addAbleEventListener, addDestBufferConnection, addPropertyChangeListener, addPropertyConnection, addSourceBufferConnection, addStateChangeListener, dataChanged, firePropertyChange, flushAbleEventQueue, getAbleEventListeners, getAbleEventProcessingEnabled, getAbleEventQueueSize, getComment, getDestBufferConnections, getFileName, getInputBuffer, getInputBuffer, getInputBufferAsString, getInputBufferAsStringArray, getInputBufferContents, getLogger, getName, getOutputBuffer, getOutputBuffer, getOutputBufferAsString, getOutputBufferAsStringArray, getOutputBufferContents, getParent, getProperties, getProperty, getPropertyChangeListeners, getPropertyConnectionManager, getSleepTime, getSourceBufferConnections, getState, getTraceLogger, handleAbleEvent, hasInputBuffer, hasOutputBuffer, init, init, isAbleEventPostingEnabled, isAbleEventProcessingEnabled, isChanged, isConnectable, isDataFlowEnabled, isTimerEventProcessingEnabled, notifyAbleEventListeners, process, process, processAbleEvent, processBufferConnections, processNoEventProcessingEnabledSituation, processTimerEvent, quitAll, quitEnabledEventProcessing, removeAbleEventListener, removeAllAbleEventListeners, removeAllBufferConnections, removeAllConnections, removeAllPropertyConnections, removeDestBufferConnection, removeProperty, removePropertyChangeListener, removePropertyConnection, removeSourceBufferConnection, removeStateChangeListener, reset, restartEnabledEventProcessing, restoreFromFile, restoreFromFile, restoreFromSerializedFile, restoreFromStream, resumeAll, resumeEnabledEventProcessing, saveToFile, saveToFile, setAbleEventProcessingEnabled, setChanged, setComment, setDataFlowEnabled, setFileName, setInputBuffer, setInputBuffer, setLogger, setName, setOutputBuffer, setOutputBuffer, setParent, setProperties, setProperty, setSleepTime, setState, setTimerEventProcessingEnabled, setTraceLogger, sourceConnectionsOK, startEnabledEventProcessing, suspendAll, suspendEnabledEventProcessing`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### NNTRAIN

    public static final int NNTRAIN

  Training mode weights are adjusted

  See Also:
    Constant Field Values

### NNTEST

    public static final int NNTEST

  Test mode weights are not adjusted performance is tested (errors are computed)

  See Also:
    Constant Field Values

### NNRUN

    public static final int NNRUN

  Application or Run mode weights are not adjusted output is produced

  See Also:
    Constant Field Values

### MODE_NAMES

    public static final java.lang.String[] MODE_NAMES

  Labels for the train, test and run modes for GUI use.

### breakPoints

    protected java.util.Vector breakPoints

  List of breakpoints defined for this object

### lastBreakPoint

    protected transient AbleBreakPoint lastBreakPoint

  The last breakpoint that fired

### breakPointFlag

    protected transient boolean breakPointFlag

  Indicates whether a breakpoint fired during the last process()

### netModelType

    protected java.lang.String netModelType

  The type of network model

### netArchitecture

    protected java.lang.String netArchitecture

  The network architecture string

### netMode

    protected int netMode

  The network mode, train, test or run

### netEpoch

    protected long netEpoch

  The current training epoch

### netRecInx

    protected long netRecInx

  The current index into the record

### netStepsPerEpoch

    protected long netStepsPerEpoch

  The number of steps before each weight adjustment

### activations

    protected double[] activations

  The activations of each unit in the network

### inNum

    public double[] inNum

  The numeric input buffer

### outNum

    public double[] outNum

  The numeric output buffer

Constructor Detail

### AbleNetwork

    public AbleNetwork()
                throws AbleException

  default constructor

### AbleNetwork

    public AbleNetwork(java.lang.String name)
                throws AbleException

  Construct a network with specified name

Parameters:
  `name` - The object name

### AbleNetwork

    public AbleNetwork(java.lang.String name,
                       java.lang.String architecture)
                throws AbleException

  Construct a network with specified name and architecture.

Parameters:
  `name` - The object name

  `architecture` - The network architecture specification

Method Detail

### getNetEpoch

    public long getNetEpoch()

### getNetRecInx

    public long getNetRecInx()

### getNetStepsPerEpoch

    public long getNetStepsPerEpoch()

### setNetStepsPerEpoch

    public void setNetStepsPerEpoch(long numSteps)

### setDefaults

    protected void setDefaults()
                        throws AbleException

  Set up the event queue behavior No timer processing and no asynch event processing

  Throws:
    `AbleException`

### clearAllBreakPoints

    public void clearAllBreakPoints()

  Clear all breakpoint set on this network.

  Returns:
    void.

### clearBreakPoint

    public void clearBreakPoint(java.lang.String parameter,
                                java.lang.String condition,
                                java.lang.String value)

  Clear the specified breakpoint from this network.

  Parameters:
    `parameter` - The name of the parameter being monitored

    `condition` - The test condition

    `value` - The value used in the test condition

### clearBreakPoint

    public void clearBreakPoint(AbleBreakPoint breakpoint)

  Clear the specified breakpoint from this network.

  Parameters:
    `breakpoint` - The breakpoint object to remove

### clearLastBreakPoint

    public void clearLastBreakPoint()

  Clear the last breakpoint to fire.

### setBreakPoint

    public void setBreakPoint(java.lang.String parameter,
                              java.lang.String condition,
                              java.lang.String value)

  Set a breakpoint on this network.

  Parameters:
    `parameter` - The name of the parameter to watch

    `condition` - The test condition

    `value` - The value of the parameter to test against

### testBreakPoints

    public boolean testBreakPoints()

  Check all active breakpoints to see if any fire.

  Returns:
    True if any breakpoints fire.

### getLastBreakPoint

    public AbleBreakPoint getLastBreakPoint()

  Get the last breakpoint to fire.

  Returns:
    AbleBreakPoint.

### breakPointReached

    public boolean breakPointReached()

  Check if any breakpoint has fired

  Returns:
    boolean.

### getNetMode

    public int getNetMode()

  Get the current operating mode of the network.

  Returns:
    int.

### setNetMode

    public void setNetMode(int mode)

  Set the operating mode of the network.

  Parameters:
    `mode` - The current operating mode, train/test/run.

### setNetArchitecture

    public void setNetArchitecture(java.lang.String architecture)
                            throws AbleException

  Set the network architecture.

  Parameters:
    `architecture` - The network architecture specification.
  Throws:
    `AbleException`

### changeNetArchitecture

    public void changeNetArchitecture(java.lang.String architecture)
                               throws AbleException

  Change the network architecture.

  Parameters:
    `architecture` - The new network architecture specification
  Throws:
    `AbleException`

### endEpoch

    public void endEpoch()

  Perform the end of epoch processing.

### getNetworkGraphicData

    public java.util.Vector getNetworkGraphicData()

  return data on the network architecture, activations, and weights for display by the AbleNetworkGraphicView custom inspector

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005